<?php
// Modifs Aur�ien PIERARD

// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_BACKUP")) return;
define("_ECRIRE_INC_BACKUP", "1");

include_ecrire ("../inc-cache.php3");


// G��ateur de nom de backup
function get_nom_backup(){
	$date=date("d-m-Y");
	$nom="backup_".$date;
	$temp_nom=$nom;
	$i=0;
	while(is_dir("data/".$temp_nom)){
		$i++;
		$temp_nom=$nom."_".$i;
	}
	$nom="data/".$temp_nom;
	return $nom;
}


// fonction qui efface un r�ertoire non vide
function EffacerRepertopireRecursif($chemin){
	$correct = 1;
	$handle  = @opendir($chemin);
	$file    = @readdir($handle);      // repertoire .
	$file    = @readdir($handle);      // repertoire ..
	while($file = @readdir($handle)){
		if(is_dir("$chemin/$file") && $file!="." && $file!=".."){
			if(EstVide("$chemin/$file")) { if(!@rmdir("$chemin/$file")) $correct = 0; }
			else $correct = EffacerRepertopireRecursif("$chemin/$file");
		}
		else @unlink("$chemin/$file");
	}
	if(!@rmdir($chemin)) $correct = 0;
	@closedir($handle);
	return $correct;
}

// fonction qui test si un r�ertoire est vide
function EstVide($chemin){
	$handle  = @opendir($chemin);
	$file    = @readdir($handle);      // repertoire .
	$file    = @readdir($handle);      // repertoire ..
	if($file = @readdir($handle) && $file!="." && $file!="..") $val = 0;
	else $val = 1;
	@closedir($handle);
	return $val;
}


// fonction qui copie un r�ertoire et son contenu
function CopierRepRecursif($source,$destination){
	$correct = 1;
	$handle  = @opendir($source);
	$file    = @readdir($handle);      // repertoire .
	$file    = @readdir($handle);      // repertoire ..

	if (is_dir($destination)){
		while($file = @readdir($handle)){
			if (($file != '.') && ($file != '..') && ($file!="CACHE") && ($file!="ecrire") && ($file!="IMG") && ($file!="oo")){
				if(is_dir("$source/$file")){
					$correct = CopierRepRecursif("$source/$file","$destination/$file");
				}
				else if(!@copy("$source/$file","$destination/$file")){
					$correct = 0;
				}
				else {
					echo _T('info_squelettes_backup_copie_fichier', array('source' => $source."/$file", 'destination' => $destination."/$file"));
				}
			}
		}
	}
	else {
		if(@mkdir($destination,0777)){
			echo _T('info_squelettes_backup_copie_rep', array('repertoire' => $destination));
			while($file = @readdir($handle)){
				if (($file != '.') && ($file != '..') && ($file!="CACHE") && ($file!="ecrire") && ($file!="IMG") && ($file!="oo")){
					if(is_dir("$source/$file")){
						$correct = CopierRepRecursif("$source/$file","$destination/$file");
					}
					else if(!@copy("$source/$file","$destination/$file")){
						$correct = 0;
					}
					else {
						echo _T('info_squelettes_backup_copie_fichier', array('source' => $source."/$file", 'destination' => $destination."/$file"));
					}
				}
			}
		}
		else {
			$correct = 0;
			echo _T('info_squelettes_backup_copie_rep_erreur', array('repertoire' => $destination));
		}
	}
	@closedir($handle);
	return $correct;
}

function backup($nom_backup){
	echo "<div style='font-size=10px; font-family: Verdana, Arial, Helvetica;'>";	
	// Backup des fichiers
	if (CopierRepRecursif("..",$nom_backup)==1){
		$erreur=0;
	}
	else {
		$erreur=1;
	}
	// copie les logos du site et l'arri�e plan :
	$handle  = @opendir("../IMG/");
	$fichier    = @readdir($handle);      // repertoire .
	$fichier    = @readdir($handle);      // repertoire ..
	while($fichier = @readdir($handle)){
		if(ereg("logogeneralon.",$fichier) || ereg("logogeneraloff.",$fichier) || ereg("background.",$fichier) || ereg("puce.",$fichier)){
			if (is_dir($nom_backup."/IMG/")){
				if(copy("../IMG/".$fichier,$nom_backup."/IMG/".$fichier)){
					echo _T('info_squelettes_backup_copie_fichier', array('source' => "IMG/".$fichier, 'destination' => $nom_backup."IMG/".$fichier));
				}
				else {
					echo _T('info_squelettes_backup_copie_fichier_erreur', array('source' => "IMG/".$fichier));			
				}
			}
			else if (mkdir($nom_backup."/IMG/",0777)){
				echo _T('info_squelettes_backup_copie_rep', array('repertoire' => $nom_backup."/IMG/"));
				if(copy("../IMG/".$fichier,$nom_backup."/IMG/".$fichier)){
					echo _T('info_squelettes_backup_copie_fichier', array('source' => "IMG/".$fichier, 'destination' => $nom_backup."IMG/".$fichier));
				}
				else {
					echo _T('info_squelettes_backup_copie_fichier_erreur', array('source' => "IMG/".$fichier));			
				}
			}
		}
	}
	echo "</div>";
	// Affichage du r�ultat
	if ($erreur==1){
		echo "</ul>";
		echo "<hr><p><h3>"._T('info_squelettes_backup_erreur_01')."</h3></b><p>"._T('info_squelettes_backup_erreur_02', array('nom_backup' => $nom_backup))." <a href='index.php3'>"._T('info_squelettes_backup_erreur_03')."</a> "._T('info_squelettes_backup_erreur_04')."<br /><br />\n";
	}
	else {
		echo "</ul>";
		echo "<hr><p><h3>"._T('info_squelettes_backup_reussi_01')."</h3></b><p>"._T('info_squelettes_backup_reussi_02', array('nom_backup' => $nom_backup))." <a href='index.php3'>"._T('info_squelettes_backup_reussi_03')."</a> "._T('info_squelettes_backup_reussi_04')."<br /><br />\n";
	}
}




// Instalation des squelettes pr��inis
function installer_squelettes($design){
	echo "<div style='font-size=10px; font-family: Verdana, Arial, Helvetica;'>";
	// Vider le repertoire CACHE
	purger_repertoire('../CACHE', 0);
	echo "<ul>";
	echo _T('info_squelettes_predefinis_01');
	echo "<br /><br />";
	// On supprime les squelettes (fichiers .html)
	if (is_dir("../")){
		if ($repertoire = opendir("../")){
			echo _T('info_squelettes_predefinis_03');
			echo "<br /><br /><ul>";
			while ($fichier = readdir($repertoire)){
				if (ereg("(.html)$",$fichier) && !ereg("(-dist.html)$",$fichier) && ($fichier!=".") && ($fichier!="..")){
					unlink("../".$fichier);
					echo _T('info_squelettes_predefinis_06', array('fichier' => $fichier));
				}
			}
			closedir($repertoire);
		}
	}
	// Suppression des r�ertoire non SPIP
	if (@is_dir("../")){
		if ($repertoire = @opendir("../")){
			while ($fichier = readdir($repertoire)){
				if (@is_dir("../".$fichier) && ($fichier!=".") && ($fichier!="..") && !ereg("CACHE",$fichier) && !ereg("ecrire",$fichier) && !ereg("IMG",$fichier) && !ereg("NAVPICS",$fichier) && !ereg("oo",$fichier)){
					if (EffacerRepertopireRecursif("../".$fichier)==1){
						echo _T('info_squelettes_predefinis_04', array('repertoire' => $fichier));
					}
					else {
						echo _T('info_squelettes_predefinis_05', array('repertoire' => $fichier));
					}
				}
			}
			echo "</ul>";
			closedir($repertoire);
		}
	}
	echo "<br/><br/>";
	echo _T('info_squelettes_predefinis_02');
	echo "<br /><br /><ul>";
	// Copie les squelettes
	if (is_dir("data/".$design."/")){
		CopierRepRecursif("data/".$design,"..");	
	}
	else {
		echo _T('info_squelettes_predefinis_erreur', array('repertoire' => "data/".$design."/"));
		$erreur=1;
	}
	// copie les logos du site et l'arri�e plan
	if (is_dir("data/".$design."/IMG/")){
		$handle  = @opendir("data/".$design."/IMG/");
		$fichier = @readdir($handle);      // repertoire .
		$fichier = @readdir($handle);      // repertoire ..
		while($fichier = @readdir($handle)){
			if(ereg("logogeneralon.",$fichier) || ereg("logogeneraloff.",$fichier) || ereg("background.",$fichier) || ereg("puce.",$fichier)){
				if (is_dir("../IMG/")){
					if(copy("data/".$design."/IMG/".$fichier,"../IMG/".$fichier)){
						echo _T('info_squelettes_backup_copie_fichier', array('source' => "data/".$design."IMG/".$fichier, 'destination' => "IMG/".$fichier));
					}
					else {
						echo _T('info_squelettes_backup_copie_fichier_erreur', array('source' => "IMG/".$fichier));			
					}
				}
			}
		}
	}
	echo "</ul></ul></div>";
	// affichage du r�ultat
	if ($erreur==1){
		echo "</ul>";
		echo "<hr><p><h3>"._T('info_squelettes_predefinis_erreur_01')."</h3></b><p>"._T('info_squelettes_predefinis_erreur_02')." <a href='index.php3'>"._T('info_squelettes_predefinis_erreur_03')."</a> "._T('info_squelettes_predefinis_erreur_04')."<br /><br />\n";
	}
	else {
		echo "</ul>";
		echo "<hr><p><h3>"._T('info_squelettes_predefinis_reussi_01')."</h3></b><p>"._T('info_squelettes_predefinis_reussi_02')." <a href='index.php3'>"._T('info_squelettes_predefinis_reussi_03')."</a> "._T('info_squelettes_predefinis_reussi_04')."<br /><br />\n";
	}
}


// Fin modifs Aur�ien PIERARD
?>

